#pragma once
/* -*-c++-*- osgVisual - Copyright (C) 2009-2011 Torben Dannhauer
 *
 * This library is based on OpenSceneGraph, open source and may be redistributed and/or modified under 
 * the terms of the OpenSceneGraph Public License (OSGPL) version 0.0 or
 * (at your option) any later version.  The full license is in LICENSE file
 * included with this distribution, and on the openscenegraph.org website.
 *
 * osgVisual requires for some proprietary modules a license from the correspondig manufacturer.
 * You have to aquire licenses for all used proprietary modules.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * OpenSceneGraph Public License for more details.
*/

#include <osg/Notify>
#include <osg/NodeVisitor>
#include <osg/PagedLOD>
#include <osgTerrain/TerrainTile>
#include <osgTerrain/Layer>

#include "ellipsoidTechnique.h"
#include "rampedEllipsoidTechnique.h"
#include "ModificationManager/ModificationManager.h"


class ModificationVisitor : public osg::NodeVisitor
{
public:
	ModificationVisitor(std::string extensionToSet);
	virtual void apply( osg::Node& node );
	virtual void apply( osg::PagedLOD& pNode );

private:
	void modifyTile(osgTerrain::TerrainTile* tile);
	std::string _extensionToSet;
	osg::ref_ptr<rampedEllipsoidTechnique> _technique;

};
